function iris(displayed_lines,displayed_columns)

if (exist('displayed_lines','var')~=1)
   displayed_lines=2;
end
if (exist('displayed_columns','var')~=1)
   displayed_columns=4;
end

load iris_logo
%figure,imagesc(iris_logo), axis off
%pause(2)
close all
%clear iris_logo

showroom_handle=figure(1);
external_query_handle=2;
displayed_images=displayed_lines*displayed_columns;

[filenames_matfile,filenames_pathname]=uigetfile('*mat','Database contents filename');
filenames_matfile=[filenames_pathname filenames_matfile];
load(filenames_matfile)

database_files=lower(database_files);
database_size=size(database_files,1);
displayed_pos=1:database_size;

[descriptor_matfile,descriptor_pathname]=uigetfile('*mat','Image descriptors filename');
descriptor_matfile=[descriptor_pathname descriptor_matfile];
load(descriptor_matfile)
if (exist('descriptor_type','var')~=1)
   descriptor_type=inf;
end
if (exist('descriptor_param','var')~=1)
   descriptor_param=[];
end
if (exist('descriptor_metric','var')~=1)
   descriptor_metric=2;
end
figure(showroom_handle)
for i=1:displayed_images,
  filename=deblank(database_files(displayed_pos(i),:));
  im=imread(filename);
  subplot(displayed_lines,displayed_columns,i),imagesc(im);
end


choice=1;
while (choice~=8)
   choice=menu('What U wanna do ?','Reset','Shuffle @','Query','External query','Next >>','Previous <<',...
      'Image Info','Bye !');
   switch (choice)
   case 1
      figure(external_query_handle),close(external_query_handle)
      displayed_pos=1:database_size;
      figure(showroom_handle)
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
   case 2
      %Shuffle
      figure(external_query_handle),close(external_query_handle)
      [dummy,displayed_pos]=sort(rand(1,database_size));
      clear dummy
      figure(showroom_handle)
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
   case 3
      % Query
      figure(external_query_handle),close(external_query_handle)
      figure(showroom_handle)
      click_type=1;
      subplot_handle=[];
      while ((click_type~=0)|(isempty(subplot_handle)))
          click_type=waitforbuttonpress;
          if (click_type==0)
             subplot_handle=fix(overobj('axes'));
          end
          subplot_handle=(subplot_handle-subplot_bias)/subplot_scale;
          filename=deblank(database_files(displayed_pos(subplot_handle),:));
          im=imread(filename);
          subplot(displayed_lines,displayed_columns,subplot_handle),imagesc(bitcmp(im,8));
          pause(0.1)
       end
      query_descriptor=descriptor(displayed_pos(subplot_handle),:);
      for i=1:database_size
          dist(i)=iris_distance(query_descriptor,descriptor(i,:),descriptor_metric);   
      end
      [dummy,displayed_pos]=sort(dist);
      figure(showroom_handle)
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
   case 4
      % External query
      % inactive if current descriptor is composite
      %descriptor_type=555;
      if (~isinf(descriptor_type))
      [query_filename,query_pathname]=uigetfile('**','Query image');
      query_filename=lower([query_pathname query_filename]);
      im=imread(query_filename);
      figure(external_query_handle),imagesc(im),axis off
      %load data_chocolate
      query_descriptor=iris_index_image(query_filename,descriptor_type,descriptor_param);
      for i=1:database_size
          dist(i)=iris_distance(query_descriptor,descriptor(i,:),descriptor_metric);   
      end     
      [dummy,displayed_pos]=sort(dist);
      figure(showroom_handle)
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
      else
         msgbox('Cannot do external querries for composite or unknown image descriptors !',...
            'IRIS Warning','warn','modal');
      end
   case 5
      % Next
      figure(showroom_handle)
      dummy=displayed_pos(1:displayed_images);
      displayed_pos(1:database_size-displayed_images)=displayed_pos(displayed_images+1:database_size);
      displayed_pos(database_size-displayed_images+1:database_size)=dummy;
      clear dummy
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
   case 6
      % Previous
      figure(showroom_handle)
      dummy=displayed_pos(database_size-displayed_images+1:database_size);
      displayed_pos(displayed_images+1:database_size)=displayed_pos(1:database_size-displayed_images);
      displayed_pos(1:displayed_images)=dummy;
      clear dummy
      for i=1:displayed_images,
         filename=deblank(database_files(displayed_pos(i),:));
         im=imread(filename);
         subplot(displayed_lines,displayed_columns,i),imagesc(im);
      end
   case 7
      % Image info
      figure(external_query_handle),close(external_query_handle)
      figure(showroom_handle)
      click_type=1;
      subplot_handle=[];
      while ((click_type~=0)|(isempty(subplot_handle)))
          click_type=waitforbuttonpress;
          if (click_type==0)
             subplot_handle=fix(overobj('axes'));
          end
          subplot_handle=(subplot_handle-subplot_bias)/subplot_scale;
      end
      query_descriptor=descriptor(displayed_pos(subplot_handle),:);
      query_filename=database_files(displayed_pos(subplot_handle),:);
      msgbox([query_filename],'IRIS Info','none','modal');
   case 8
      % equivalent otherwise, Bye !
      close all
   end
   
end
clear all