function [precision,recognition,recall,fh]=iris_eval(dat,C)

if (isempty(dat))
  [descriptor_matfile,descriptor_pathname]=uigetfile('*mat','Image descriptors filename');
  descriptor_matfile=[descriptor_pathname descriptor_matfile];
  load(descriptor_matfile)
  dat=descriptor;
  clear descriptor
end

dat=dat';

if ~exist('C','var')
   C = 10;
end

[Length Nb_vectors]=size(dat);

for pos=1:Nb_vectors
   ind_class=floor((pos-1)/C);
	lim_inf=ind_class*C+1;
	lim_sup=lim_inf+C-1;
	[valori,pozitii]=sort(sum((dat-dat(:,pos)*ones(1,Nb_vectors)).^2,1));
	vect=find(pozitii>=lim_inf & pozitii<=lim_sup);
	precision(pos,:)=(1:C)./vect;
   first_hit(pos)=vect(2);
   
	prec1=length(find(pozitii(2:2)>=lim_inf & pozitii(2:2)<=lim_sup));
	prec3=length(find(pozitii(2:4)>=lim_inf & pozitii(2:4)<=lim_sup));
	prec5=length(find(pozitii(2:6)>=lim_inf & pozitii(2:6)<=lim_sup));
	prec7=length(find(pozitii(2:8)>=lim_inf & pozitii(2:8)<=lim_sup));
	knn(pos,:)=[prec1 prec3 prec5 prec7];
end

precision=mean(precision);
recall = 1/C:(1/C):1;

for j=1:4
   recognition(j)=length(find(knn(:,j)>=j))/Nb_vectors;
end

fh=mean(first_hit);
