function out=iris_index_image(filename,tip,param)

if (exist('tip','var')==0)
   tip=1;
end

if (exist('param','var')==0)
   param=[];
end

x=imread(filename);
r=(double(x(:,:,1))-1)/255;
g=(double(x(:,:,2))-1)/255;
b=(double(x(:,:,3))-1)/255;
[h,w]=size(r);

switch tip
case 10
   y=0.3*r+0.6*g+0.1*b;
   out=mas_four(fftshift(abs(fft2(y))));
case 666
   bins=param(1);
   y=fix(bins*r)+bins*fix(bins*g)+bins*bins*fix(bins*b)+1;
   load flut6_75
   for l=1:bins*bins*bins
      temp=reshape(flut(y,l),size(y));
      temp=conv2(temp,[1 2 4;128 0 8;64 32 16],'same');
      out(l)=mean(temp(:));
   end
case 1
   % couleur moyenne normalisee
   out=mean([r(:) g(:) b(:)]);
case 2
   % histogramme rgb
   if (max(size(param))==1);
      bins=param;
   else
      bins=6;
   end
   y=fix(r*bins)+bins*fix(g*bins)+bins*bins*fix(b*bins)+1;
   out=hist(y(:),bins*bins*bins)/(h*w);
case 3
   % histogramme niveaux de gris
   y=[r(:) g(:) b(:)]*[0.3;0.6;0.1];
   if (length(param));
      bins=param(1);
   else
      bins=16;
   end
   out=hist(fix(y*bins),bins)/(h*w);
case 4
   % saturation moyenne
    sat=mean(rgb2hsv([r(:) g(:) b(:)]));
    out=sat(2);
case 5
    % Paschos color moments
    if (isempty(param))
       bins=100;
    else
       bins=param;
    end
    out=iris_paschos(r,g,b,bins);
 case 6
    switch (length(param))
    case 3
       bins=param(1);
       tip=param(2);
       levels=param(3);
    case 2
       bins=param(1);
       tip=param(2);
       levels=1;
    case 1
       bins=param(1);
       tip=3;
       levels=1;
    otherwise
       bins=16;
       tip=3;
       levels=1;
    end
        
    y=[r(:) g(:) b(:)]*[0.3;0.6;0.1];
    y=fix(bins*y);
    prag=1/levels:1/levels:1;
    out=[];
    for i=1:levels
      ldp=iris_ldp_matrix(y,i/levels,round(bins/10));
      out=[out iris_ldp_param(ldp,tip)];
      ldp=iris_ldp_matrix(y',i/levels,round(bins/10));
      out=[out iris_ldp_param(ldp,tip)];
    end
case 100
    % palette de couleur
    if (isempty(param))
       nb_cul=8;
    else
       nb_cul=param(1);
    end
    [ind,map]=rgb2ind(x,nb_cul);
    h=hist(double(ind(:)),nb_cul);
    dat=[map (h/sum(h))'];
    out=(dat(:))';
case 101
    % mean color symmetry index
    y=fix(r*6)+6*fix(g*6)+36*fix(b*6)+1;
    indexmap=zeros(h,w);
    load fuzlut
    if (isempty(param))
       D=3;
    else
       D=param;
    end
    for i=1+D:h-D
      for j=1+D:w-D
        temp=y(i-D:i+D,j-D:j+D);
        ttemp=fuzlut(temp(:),y(i,j));
        ttemp=reshape(ttemp,2*D+1,2*D+1);      
        indexmap(i,j)=iris_symindex(ttemp);
      end
    end
    out=mean(indexmap(:));
otherwise
   % par defaut: couleur moyenne normalisee
    out=mean([r(:) g(:) b(:)]);
end


        
   